<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfNotaFiscalConsultaDTO ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfNotaFiscalConsultaDTO
 * @subpackage Arrays
 */
class ArrayOfNotaFiscalConsultaDTO extends AbstractStructArrayBase
{
    /**
     * The NotaFiscalConsultaDTO
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\NotaFiscalConsultaDTO[]
     */
    public $NotaFiscalConsultaDTO;
    /**
     * Constructor method for ArrayOfNotaFiscalConsultaDTO
     * @uses ArrayOfNotaFiscalConsultaDTO::setNotaFiscalConsultaDTO()
     * @param \StructType\NotaFiscalConsultaDTO[] $notaFiscalConsultaDTO
     */
    public function __construct(array $notaFiscalConsultaDTO = array())
    {
        $this
            ->setNotaFiscalConsultaDTO($notaFiscalConsultaDTO);
    }
    /**
     * Get NotaFiscalConsultaDTO value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\NotaFiscalConsultaDTO[]|null
     */
    public function getNotaFiscalConsultaDTO()
    {
        return isset($this->NotaFiscalConsultaDTO) ? $this->NotaFiscalConsultaDTO : null;
    }
    /**
     * This method is responsible for validating the values passed to the setNotaFiscalConsultaDTO method
     * This method is willingly generated in order to preserve the one-line inline validation within the setNotaFiscalConsultaDTO method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateNotaFiscalConsultaDTOForArrayConstraintsFromSetNotaFiscalConsultaDTO(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfNotaFiscalConsultaDTONotaFiscalConsultaDTOItem) {
            // validation for constraint: itemType
            if (!$arrayOfNotaFiscalConsultaDTONotaFiscalConsultaDTOItem instanceof \StructType\NotaFiscalConsultaDTO) {
                $invalidValues[] = is_object($arrayOfNotaFiscalConsultaDTONotaFiscalConsultaDTOItem) ? get_class($arrayOfNotaFiscalConsultaDTONotaFiscalConsultaDTOItem) : sprintf('%s(%s)', gettype($arrayOfNotaFiscalConsultaDTONotaFiscalConsultaDTOItem), var_export($arrayOfNotaFiscalConsultaDTONotaFiscalConsultaDTOItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The NotaFiscalConsultaDTO property can only contain items of type \StructType\NotaFiscalConsultaDTO, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set NotaFiscalConsultaDTO value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\NotaFiscalConsultaDTO[] $notaFiscalConsultaDTO
     * @return \ArrayType\ArrayOfNotaFiscalConsultaDTO
     */
    public function setNotaFiscalConsultaDTO(array $notaFiscalConsultaDTO = array())
    {
        // validation for constraint: array
        if ('' !== ($notaFiscalConsultaDTOArrayErrorMessage = self::validateNotaFiscalConsultaDTOForArrayConstraintsFromSetNotaFiscalConsultaDTO($notaFiscalConsultaDTO))) {
            throw new \InvalidArgumentException($notaFiscalConsultaDTOArrayErrorMessage, __LINE__);
        }
        if (is_null($notaFiscalConsultaDTO) || (is_array($notaFiscalConsultaDTO) && empty($notaFiscalConsultaDTO))) {
            unset($this->NotaFiscalConsultaDTO);
        } else {
            $this->NotaFiscalConsultaDTO = $notaFiscalConsultaDTO;
        }
        return $this;
    }
    /**
     * Add item to NotaFiscalConsultaDTO value
     * @throws \InvalidArgumentException
     * @param \StructType\NotaFiscalConsultaDTO $item
     * @return \ArrayType\ArrayOfNotaFiscalConsultaDTO
     */
    public function addToNotaFiscalConsultaDTO(\StructType\NotaFiscalConsultaDTO $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\NotaFiscalConsultaDTO) {
            throw new \InvalidArgumentException(sprintf('The NotaFiscalConsultaDTO property can only contain items of type \StructType\NotaFiscalConsultaDTO, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->NotaFiscalConsultaDTO[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\NotaFiscalConsultaDTO|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\NotaFiscalConsultaDTO|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\NotaFiscalConsultaDTO|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\NotaFiscalConsultaDTO|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\NotaFiscalConsultaDTO|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string NotaFiscalConsultaDTO
     */
    public function getAttributeName()
    {
        return 'NotaFiscalConsultaDTO';
    }
}
