<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ConsultaNotaFiscalRequest StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ConsultaNotaFiscalRequest
 * @subpackage Structs
 */
class ConsultaNotaFiscalRequest extends RequestBase
{
    /**
     * The ChaveAutenticacao
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ChaveAutenticacao;
    /**
     * The DataFinal
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DataFinal;
    /**
     * The DataInicial
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DataInicial;
    /**
     * The NumeroReciboFinal
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var float
     */
    public $NumeroReciboFinal;
    /**
     * The NumeroReciboInicial
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var float
     */
    public $NumeroReciboInicial;
    /**
     * The NumeroReciboUnico
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var float
     */
    public $NumeroReciboUnico;
    /**
     * Constructor method for ConsultaNotaFiscalRequest
     * @uses ConsultaNotaFiscalRequest::setChaveAutenticacao()
     * @uses ConsultaNotaFiscalRequest::setDataFinal()
     * @uses ConsultaNotaFiscalRequest::setDataInicial()
     * @uses ConsultaNotaFiscalRequest::setNumeroReciboFinal()
     * @uses ConsultaNotaFiscalRequest::setNumeroReciboInicial()
     * @uses ConsultaNotaFiscalRequest::setNumeroReciboUnico()
     * @param string $chaveAutenticacao
     * @param string $dataFinal
     * @param string $dataInicial
     * @param float $numeroReciboFinal
     * @param float $numeroReciboInicial
     * @param float $numeroReciboUnico
     */
    public function __construct($chaveAutenticacao = null, $dataFinal = null, $dataInicial = null, $numeroReciboFinal = null, $numeroReciboInicial = null, $numeroReciboUnico = null)
    {
        $this
            ->setChaveAutenticacao($chaveAutenticacao)
            ->setDataFinal($dataFinal)
            ->setDataInicial($dataInicial)
            ->setNumeroReciboFinal($numeroReciboFinal)
            ->setNumeroReciboInicial($numeroReciboInicial)
            ->setNumeroReciboUnico($numeroReciboUnico);
    }
    /**
     * Get ChaveAutenticacao value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getChaveAutenticacao()
    {
        return isset($this->ChaveAutenticacao) ? $this->ChaveAutenticacao : null;
    }
    /**
     * Set ChaveAutenticacao value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $chaveAutenticacao
     * @return \StructType\ConsultaNotaFiscalRequest
     */
    public function setChaveAutenticacao($chaveAutenticacao = null)
    {
        // validation for constraint: string
        if (!is_null($chaveAutenticacao) && !is_string($chaveAutenticacao)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($chaveAutenticacao, true), gettype($chaveAutenticacao)), __LINE__);
        }
        if (is_null($chaveAutenticacao) || (is_array($chaveAutenticacao) && empty($chaveAutenticacao))) {
            unset($this->ChaveAutenticacao);
        } else {
            $this->ChaveAutenticacao = $chaveAutenticacao;
        }
        return $this;
    }
    /**
     * Get DataFinal value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDataFinal()
    {
        return isset($this->DataFinal) ? $this->DataFinal : null;
    }
    /**
     * Set DataFinal value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dataFinal
     * @return \StructType\ConsultaNotaFiscalRequest
     */
    public function setDataFinal($dataFinal = null)
    {
        // validation for constraint: string
        if (!is_null($dataFinal) && !is_string($dataFinal)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dataFinal, true), gettype($dataFinal)), __LINE__);
        }
        if (is_null($dataFinal) || (is_array($dataFinal) && empty($dataFinal))) {
            unset($this->DataFinal);
        } else {
            $this->DataFinal = $dataFinal;
        }
        return $this;
    }
    /**
     * Get DataInicial value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDataInicial()
    {
        return isset($this->DataInicial) ? $this->DataInicial : null;
    }
    /**
     * Set DataInicial value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dataInicial
     * @return \StructType\ConsultaNotaFiscalRequest
     */
    public function setDataInicial($dataInicial = null)
    {
        // validation for constraint: string
        if (!is_null($dataInicial) && !is_string($dataInicial)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dataInicial, true), gettype($dataInicial)), __LINE__);
        }
        if (is_null($dataInicial) || (is_array($dataInicial) && empty($dataInicial))) {
            unset($this->DataInicial);
        } else {
            $this->DataInicial = $dataInicial;
        }
        return $this;
    }
    /**
     * Get NumeroReciboFinal value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return float|null
     */
    public function getNumeroReciboFinal()
    {
        return isset($this->NumeroReciboFinal) ? $this->NumeroReciboFinal : null;
    }
    /**
     * Set NumeroReciboFinal value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param float $numeroReciboFinal
     * @return \StructType\ConsultaNotaFiscalRequest
     */
    public function setNumeroReciboFinal($numeroReciboFinal = null)
    {
        // validation for constraint: float
        if (!is_null($numeroReciboFinal) && !(is_float($numeroReciboFinal) || is_numeric($numeroReciboFinal))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($numeroReciboFinal, true), gettype($numeroReciboFinal)), __LINE__);
        }
        if (is_null($numeroReciboFinal) || (is_array($numeroReciboFinal) && empty($numeroReciboFinal))) {
            unset($this->NumeroReciboFinal);
        } else {
            $this->NumeroReciboFinal = $numeroReciboFinal;
        }
        return $this;
    }
    /**
     * Get NumeroReciboInicial value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return float|null
     */
    public function getNumeroReciboInicial()
    {
        return isset($this->NumeroReciboInicial) ? $this->NumeroReciboInicial : null;
    }
    /**
     * Set NumeroReciboInicial value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param float $numeroReciboInicial
     * @return \StructType\ConsultaNotaFiscalRequest
     */
    public function setNumeroReciboInicial($numeroReciboInicial = null)
    {
        // validation for constraint: float
        if (!is_null($numeroReciboInicial) && !(is_float($numeroReciboInicial) || is_numeric($numeroReciboInicial))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($numeroReciboInicial, true), gettype($numeroReciboInicial)), __LINE__);
        }
        if (is_null($numeroReciboInicial) || (is_array($numeroReciboInicial) && empty($numeroReciboInicial))) {
            unset($this->NumeroReciboInicial);
        } else {
            $this->NumeroReciboInicial = $numeroReciboInicial;
        }
        return $this;
    }
    /**
     * Get NumeroReciboUnico value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return float|null
     */
    public function getNumeroReciboUnico()
    {
        return isset($this->NumeroReciboUnico) ? $this->NumeroReciboUnico : null;
    }
    /**
     * Set NumeroReciboUnico value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param float $numeroReciboUnico
     * @return \StructType\ConsultaNotaFiscalRequest
     */
    public function setNumeroReciboUnico($numeroReciboUnico = null)
    {
        // validation for constraint: float
        if (!is_null($numeroReciboUnico) && !(is_float($numeroReciboUnico) || is_numeric($numeroReciboUnico))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($numeroReciboUnico, true), gettype($numeroReciboUnico)), __LINE__);
        }
        if (is_null($numeroReciboUnico) || (is_array($numeroReciboUnico) && empty($numeroReciboUnico))) {
            unset($this->NumeroReciboUnico);
        } else {
            $this->NumeroReciboUnico = $numeroReciboUnico;
        }
        return $this;
    }
}
