<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EnderecoDTO StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:EnderecoDTO
 * @subpackage Structs
 */
class EnderecoDTO extends AbstractStructBase
{
    /**
     * The Bairro
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Bairro;
    /**
     * The CEP
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CEP;
    /**
     * The Cidade
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Cidade;
    /**
     * The Complemento
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Complemento;
    /**
     * The Estado
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Estado;
    /**
     * The Logradouro
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Logradouro;
    /**
     * The Numero
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Numero;
    /**
     * The Pais
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Pais;
    /**
     * The TipoLogradouro
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TipoLogradouro;
    /**
     * Constructor method for EnderecoDTO
     * @uses EnderecoDTO::setBairro()
     * @uses EnderecoDTO::setCEP()
     * @uses EnderecoDTO::setCidade()
     * @uses EnderecoDTO::setComplemento()
     * @uses EnderecoDTO::setEstado()
     * @uses EnderecoDTO::setLogradouro()
     * @uses EnderecoDTO::setNumero()
     * @uses EnderecoDTO::setPais()
     * @uses EnderecoDTO::setTipoLogradouro()
     * @param string $bairro
     * @param string $cEP
     * @param string $cidade
     * @param string $complemento
     * @param string $estado
     * @param string $logradouro
     * @param string $numero
     * @param string $pais
     * @param string $tipoLogradouro
     */
    public function __construct($bairro = null, $cEP = null, $cidade = null, $complemento = null, $estado = null, $logradouro = null, $numero = null, $pais = null, $tipoLogradouro = null)
    {
        $this
            ->setBairro($bairro)
            ->setCEP($cEP)
            ->setCidade($cidade)
            ->setComplemento($complemento)
            ->setEstado($estado)
            ->setLogradouro($logradouro)
            ->setNumero($numero)
            ->setPais($pais)
            ->setTipoLogradouro($tipoLogradouro);
    }
    /**
     * Get Bairro value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getBairro()
    {
        return isset($this->Bairro) ? $this->Bairro : null;
    }
    /**
     * Set Bairro value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $bairro
     * @return \StructType\EnderecoDTO
     */
    public function setBairro($bairro = null)
    {
        // validation for constraint: string
        if (!is_null($bairro) && !is_string($bairro)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($bairro, true), gettype($bairro)), __LINE__);
        }
        if (is_null($bairro) || (is_array($bairro) && empty($bairro))) {
            unset($this->Bairro);
        } else {
            $this->Bairro = $bairro;
        }
        return $this;
    }
    /**
     * Get CEP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCEP()
    {
        return isset($this->CEP) ? $this->CEP : null;
    }
    /**
     * Set CEP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cEP
     * @return \StructType\EnderecoDTO
     */
    public function setCEP($cEP = null)
    {
        // validation for constraint: string
        if (!is_null($cEP) && !is_string($cEP)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cEP, true), gettype($cEP)), __LINE__);
        }
        if (is_null($cEP) || (is_array($cEP) && empty($cEP))) {
            unset($this->CEP);
        } else {
            $this->CEP = $cEP;
        }
        return $this;
    }
    /**
     * Get Cidade value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCidade()
    {
        return isset($this->Cidade) ? $this->Cidade : null;
    }
    /**
     * Set Cidade value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cidade
     * @return \StructType\EnderecoDTO
     */
    public function setCidade($cidade = null)
    {
        // validation for constraint: string
        if (!is_null($cidade) && !is_string($cidade)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cidade, true), gettype($cidade)), __LINE__);
        }
        if (is_null($cidade) || (is_array($cidade) && empty($cidade))) {
            unset($this->Cidade);
        } else {
            $this->Cidade = $cidade;
        }
        return $this;
    }
    /**
     * Get Complemento value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getComplemento()
    {
        return isset($this->Complemento) ? $this->Complemento : null;
    }
    /**
     * Set Complemento value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $complemento
     * @return \StructType\EnderecoDTO
     */
    public function setComplemento($complemento = null)
    {
        // validation for constraint: string
        if (!is_null($complemento) && !is_string($complemento)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($complemento, true), gettype($complemento)), __LINE__);
        }
        if (is_null($complemento) || (is_array($complemento) && empty($complemento))) {
            unset($this->Complemento);
        } else {
            $this->Complemento = $complemento;
        }
        return $this;
    }
    /**
     * Get Estado value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getEstado()
    {
        return isset($this->Estado) ? $this->Estado : null;
    }
    /**
     * Set Estado value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $estado
     * @return \StructType\EnderecoDTO
     */
    public function setEstado($estado = null)
    {
        // validation for constraint: string
        if (!is_null($estado) && !is_string($estado)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($estado, true), gettype($estado)), __LINE__);
        }
        if (is_null($estado) || (is_array($estado) && empty($estado))) {
            unset($this->Estado);
        } else {
            $this->Estado = $estado;
        }
        return $this;
    }
    /**
     * Get Logradouro value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLogradouro()
    {
        return isset($this->Logradouro) ? $this->Logradouro : null;
    }
    /**
     * Set Logradouro value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $logradouro
     * @return \StructType\EnderecoDTO
     */
    public function setLogradouro($logradouro = null)
    {
        // validation for constraint: string
        if (!is_null($logradouro) && !is_string($logradouro)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($logradouro, true), gettype($logradouro)), __LINE__);
        }
        if (is_null($logradouro) || (is_array($logradouro) && empty($logradouro))) {
            unset($this->Logradouro);
        } else {
            $this->Logradouro = $logradouro;
        }
        return $this;
    }
    /**
     * Get Numero value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNumero()
    {
        return isset($this->Numero) ? $this->Numero : null;
    }
    /**
     * Set Numero value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $numero
     * @return \StructType\EnderecoDTO
     */
    public function setNumero($numero = null)
    {
        // validation for constraint: string
        if (!is_null($numero) && !is_string($numero)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($numero, true), gettype($numero)), __LINE__);
        }
        if (is_null($numero) || (is_array($numero) && empty($numero))) {
            unset($this->Numero);
        } else {
            $this->Numero = $numero;
        }
        return $this;
    }
    /**
     * Get Pais value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPais()
    {
        return isset($this->Pais) ? $this->Pais : null;
    }
    /**
     * Set Pais value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $pais
     * @return \StructType\EnderecoDTO
     */
    public function setPais($pais = null)
    {
        // validation for constraint: string
        if (!is_null($pais) && !is_string($pais)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pais, true), gettype($pais)), __LINE__);
        }
        if (is_null($pais) || (is_array($pais) && empty($pais))) {
            unset($this->Pais);
        } else {
            $this->Pais = $pais;
        }
        return $this;
    }
    /**
     * Get TipoLogradouro value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTipoLogradouro()
    {
        return isset($this->TipoLogradouro) ? $this->TipoLogradouro : null;
    }
    /**
     * Set TipoLogradouro value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $tipoLogradouro
     * @return \StructType\EnderecoDTO
     */
    public function setTipoLogradouro($tipoLogradouro = null)
    {
        // validation for constraint: string
        if (!is_null($tipoLogradouro) && !is_string($tipoLogradouro)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tipoLogradouro, true), gettype($tipoLogradouro)), __LINE__);
        }
        if (is_null($tipoLogradouro) || (is_array($tipoLogradouro) && empty($tipoLogradouro))) {
            unset($this->TipoLogradouro);
        } else {
            $this->TipoLogradouro = $tipoLogradouro;
        }
        return $this;
    }
}
