<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for NotaFiscalLoteGeradaDTO StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:NotaFiscalLoteGeradaDTO
 * @subpackage Structs
 */
class NotaFiscalLoteGeradaDTO extends NotaFiscalGeradaDTO
{
    /**
     * The EquipamentoRecibo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $EquipamentoRecibo;
    /**
     * The Erro
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $Erro;
    /**
     * The Identificador
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Identificador;
    /**
     * The MensagemErro
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $MensagemErro;
    /**
     * The Recibo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Recibo;
    /**
     * Constructor method for NotaFiscalLoteGeradaDTO
     * @uses NotaFiscalLoteGeradaDTO::setEquipamentoRecibo()
     * @uses NotaFiscalLoteGeradaDTO::setErro()
     * @uses NotaFiscalLoteGeradaDTO::setIdentificador()
     * @uses NotaFiscalLoteGeradaDTO::setMensagemErro()
     * @uses NotaFiscalLoteGeradaDTO::setRecibo()
     * @param string $equipamentoRecibo
     * @param bool $erro
     * @param string $identificador
     * @param string $mensagemErro
     * @param string $recibo
     */
    public function __construct($equipamentoRecibo = null, $erro = null, $identificador = null, $mensagemErro = null, $recibo = null)
    {
        $this
            ->setEquipamentoRecibo($equipamentoRecibo)
            ->setErro($erro)
            ->setIdentificador($identificador)
            ->setMensagemErro($mensagemErro)
            ->setRecibo($recibo);
    }
    /**
     * Get EquipamentoRecibo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getEquipamentoRecibo()
    {
        return isset($this->EquipamentoRecibo) ? $this->EquipamentoRecibo : null;
    }
    /**
     * Set EquipamentoRecibo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $equipamentoRecibo
     * @return \StructType\NotaFiscalLoteGeradaDTO
     */
    public function setEquipamentoRecibo($equipamentoRecibo = null)
    {
        // validation for constraint: string
        if (!is_null($equipamentoRecibo) && !is_string($equipamentoRecibo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($equipamentoRecibo, true), gettype($equipamentoRecibo)), __LINE__);
        }
        if (is_null($equipamentoRecibo) || (is_array($equipamentoRecibo) && empty($equipamentoRecibo))) {
            unset($this->EquipamentoRecibo);
        } else {
            $this->EquipamentoRecibo = $equipamentoRecibo;
        }
        return $this;
    }
    /**
     * Get Erro value
     * @return bool|null
     */
    public function getErro()
    {
        return $this->Erro;
    }
    /**
     * Set Erro value
     * @param bool $erro
     * @return \StructType\NotaFiscalLoteGeradaDTO
     */
    public function setErro($erro = null)
    {
        // validation for constraint: boolean
        if (!is_null($erro) && !is_bool($erro)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($erro, true), gettype($erro)), __LINE__);
        }
        $this->Erro = $erro;
        return $this;
    }
    /**
     * Get Identificador value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getIdentificador()
    {
        return isset($this->Identificador) ? $this->Identificador : null;
    }
    /**
     * Set Identificador value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $identificador
     * @return \StructType\NotaFiscalLoteGeradaDTO
     */
    public function setIdentificador($identificador = null)
    {
        // validation for constraint: string
        if (!is_null($identificador) && !is_string($identificador)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($identificador, true), gettype($identificador)), __LINE__);
        }
        if (is_null($identificador) || (is_array($identificador) && empty($identificador))) {
            unset($this->Identificador);
        } else {
            $this->Identificador = $identificador;
        }
        return $this;
    }
    /**
     * Get MensagemErro value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMensagemErro()
    {
        return isset($this->MensagemErro) ? $this->MensagemErro : null;
    }
    /**
     * Set MensagemErro value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $mensagemErro
     * @return \StructType\NotaFiscalLoteGeradaDTO
     */
    public function setMensagemErro($mensagemErro = null)
    {
        // validation for constraint: string
        if (!is_null($mensagemErro) && !is_string($mensagemErro)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mensagemErro, true), gettype($mensagemErro)), __LINE__);
        }
        if (is_null($mensagemErro) || (is_array($mensagemErro) && empty($mensagemErro))) {
            unset($this->MensagemErro);
        } else {
            $this->MensagemErro = $mensagemErro;
        }
        return $this;
    }
    /**
     * Get Recibo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRecibo()
    {
        return isset($this->Recibo) ? $this->Recibo : null;
    }
    /**
     * Set Recibo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $recibo
     * @return \StructType\NotaFiscalLoteGeradaDTO
     */
    public function setRecibo($recibo = null)
    {
        // validation for constraint: string
        if (!is_null($recibo) && !is_string($recibo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($recibo, true), gettype($recibo)), __LINE__);
        }
        if (is_null($recibo) || (is_array($recibo) && empty($recibo))) {
            unset($this->Recibo);
        } else {
            $this->Recibo = $recibo;
        }
        return $this;
    }
}
