<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for NotasFiscaisLoteDTO StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:NotasFiscaisLoteDTO
 * @subpackage Structs
 */
class NotasFiscaisLoteDTO extends AbstractStructBase
{
    /**
     * The ChaveAutenticacao
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $ChaveAutenticacao;
    /**
     * The EmailContato
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $EmailContato;
    /**
     * The Notas
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfNotaFiscalLoteDTO
     */
    public $Notas;
    /**
     * Constructor method for NotasFiscaisLoteDTO
     * @uses NotasFiscaisLoteDTO::setChaveAutenticacao()
     * @uses NotasFiscaisLoteDTO::setEmailContato()
     * @uses NotasFiscaisLoteDTO::setNotas()
     * @param string $chaveAutenticacao
     * @param string $emailContato
     * @param \ArrayType\ArrayOfNotaFiscalLoteDTO $notas
     */
    public function __construct($chaveAutenticacao = null, $emailContato = null, \ArrayType\ArrayOfNotaFiscalLoteDTO $notas = null)
    {
        $this
            ->setChaveAutenticacao($chaveAutenticacao)
            ->setEmailContato($emailContato)
            ->setNotas($notas);
    }
    /**
     * Get ChaveAutenticacao value
     * @return string|null
     */
    public function getChaveAutenticacao()
    {
        return $this->ChaveAutenticacao;
    }
    /**
     * Set ChaveAutenticacao value
     * @param string $chaveAutenticacao
     * @return \StructType\NotasFiscaisLoteDTO
     */
    public function setChaveAutenticacao($chaveAutenticacao = null)
    {
        // validation for constraint: string
        if (!is_null($chaveAutenticacao) && !is_string($chaveAutenticacao)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($chaveAutenticacao, true), gettype($chaveAutenticacao)), __LINE__);
        }
        $this->ChaveAutenticacao = $chaveAutenticacao;
        return $this;
    }
    /**
     * Get EmailContato value
     * @return string|null
     */
    public function getEmailContato()
    {
        return $this->EmailContato;
    }
    /**
     * Set EmailContato value
     * @param string $emailContato
     * @return \StructType\NotasFiscaisLoteDTO
     */
    public function setEmailContato($emailContato = null)
    {
        // validation for constraint: string
        if (!is_null($emailContato) && !is_string($emailContato)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($emailContato, true), gettype($emailContato)), __LINE__);
        }
        $this->EmailContato = $emailContato;
        return $this;
    }
    /**
     * Get Notas value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfNotaFiscalLoteDTO|null
     */
    public function getNotas()
    {
        return isset($this->Notas) ? $this->Notas : null;
    }
    /**
     * Set Notas value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfNotaFiscalLoteDTO $notas
     * @return \StructType\NotasFiscaisLoteDTO
     */
    public function setNotas(\ArrayType\ArrayOfNotaFiscalLoteDTO $notas = null)
    {
        if (is_null($notas) || (is_array($notas) && empty($notas))) {
            unset($this->Notas);
        } else {
            $this->Notas = $notas;
        }
        return $this;
    }
}
